program test

#include "petsc/finclude/petscdmplex.h"
#include "petsc/finclude/petscdmlabel.h"
 use petscdmplex
 use petscsys

 implicit none

 DM                                :: dm, dm_orig, dm_geom
 PetscSF                           :: sf_nat
 PetscMPIInt                       :: myid, nproc
 PetscErrorCode                    :: ierr

 call PetscInitialize(PETSC_NULL_CHARACTER, ierr)
 if(ierr.ne.0) then
   write(*,*) 'Fail to initialize PETSc ...'
   stop
 endif

 call MPI_COMM_RANK(MPI_COMM_WORLD, myid, ierr)
 call MPI_COMM_SIZE(MPI_COMM_WORLD, nproc, ierr)
 write(*,*) 'MPI information ... ', myid, nproc

 call DMCreate(PETSC_COMM_WORLD, dm, ierr);CHKERRA(ierr)
 call DMSetType(dm, DMPLEX, ierr);CHKERRA(ierr)

 call DMSetUseNatural(dm, PETSC_TRUE, ierr);CHKERRA(ierr)

 call DMSetFromOptions(dm, ierr);CHKERRA(ierr)

 call DMGetNaturalSF(dm, sf_nat, ierr);CHKERRA(ierr)
 ! NULL sf_nat returned
 call PetscSFView(sf_nat, PETSC_VIEWER_STDOUT_WORLD, ierr);CHKERRA(ierr)

 call DMViewFromOptions(dm, PETSC_NULL_VEC, '-dm_view', ierr);CHKERRA(ierr)

 call DMDestroy(dm, ierr);CHKERRA(ierr)
 call PetscFinalize(ierr)

 stop
end program test
